/* ReSCAL - Stochastic simulation engine
 *
 * Copyright (C) 2011
 *
 * Author: Olivier Rozier <rozier@ipgp.fr>
 *
 * This file is part of ReSCAL.
 *
 * ReSCAL is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#define NB_EVT_MAX 20

enum TIME_UNIT {UNIT_COMP, UNIT_T0, UNIT_RT};

enum TIME_CORR {TC_MAXI, TC_CGV, TC_MINI};

enum EVT_FAMILY {FAMILY_SAVE, FAMILY_SIMUL, FAMILY_ALL};

enum EVT_TYPE {EVT_LOG, EVT_SAVE_CSP, EVT_SAVE_PNG, EVT_TIME_CORR};

enum CSP_TEMPLATES {CSP_CUSTOM, CSP_SRC_DISK_CEIL, CSP_SRC_RECT, CSP_2_SRC_DISK_CEIL};

typedef struct regular_event{
  int type;
  double delay;
  double time_threshold;
} Reg_evt;

typedef struct event_scheduler{
  int family;
  int nb_events;
  double next_time_threshold;
  //double epsilon;
  Reg_evt evt[NB_EVT_MAX];
} Evt_sched;

void init_simul();
void params_simul();
int simul_csp();
void simul_lgca();
void dump_time();
void simul_add_event(int type, double delay);


